@echo off

@rem 
@rem To change the number of remote users, change the num variable to the 
@rem desired amount.
@rem
set num=1

@rem 
@rem Stop the MobiLink Server, as well as the database engine
@rem
mlstop -w
start /wait dbstop -y -c "eng=cons;dbn=cons;uid=dba;pwd=sql"

@rem 
@rem Erase Old database files from previous runs
@rem
dberase -y cons\cons.db
for /L %%i in (1,1,%num%) do dberase -y rem%%i\rem%%i.db

@rem 
@rem Empty out and remove the directories where the databases from 
@rem previous runs were stored
@rem 
erase /Q /F cons
for /L %%i in (1,1,%num%) do erase /Q /F rem%%i
rmdir cons
for /L %%i in (1,1,%num%) do rmdir rem%%i

@rem 
@rem Erase all files in the current directory that do not belong to 
@rem this sample
@rem 
attrib -r *.*
attrib +r *.bat
attrib +r *.sql
attrib +r readme.txt
echo y|del *.*
attrib -r *.bat
attrib -r *.sql
attrib -r readme.txt

@rem
@rem Create a DSN for the MobiLink Server
@rem 
dbdsn -y -wu MultiplePubsDelayHook -c "eng=cons;dbn=cons;uid=dba;pwd=sql"

@rem
@rem Create the directories to store the database files
@rem
mkdir cons
for /L %%i in (1,1,%num%) do mkdir rem%%i

@rem 
@rem Create an empty database if one does not already exist.
@rem 
if not exist tempDB mkdir tempDB
if not exist tempDB\cons.db dbinit -p 4096 tempDB\cons.db -n

@rem 
@rem Copy the empty database into the directories for the databases
@rem 
copy tempDB\cons.db cons\cons.db
for /L %%i in (1,1,%num%) do copy tempDB\cons.db rem%%i\rem%%i.db
dblog -t cons.log cons\cons.db
for /L %%i in (1,1,%num%) do dblog -t rem%%i.log rem%%i\rem%%i.db

@rem 
@rem Create the consolidated database and start the database engine
@rem See the cons.sql file to see the schema for the consolidated database
@rem 
dbisql -nogui -c "uid=dba;pwd=sql;eng=cons;dbf=cons\cons.db;autostop=no;start=dbsrv10 -gd all -x none" read "%SQLANY10%\mobilink\setup\syncsa.sql"
dbisql -nogui -c "uid=dba;pwd=sql;eng=cons;dbn=cons" read cons.sql 

@rem 
@rem Create the remote databases
@rem See the rem.sql file to see the schema for the remote databases
@rem 
for /L %%i in (1,1,%num%) do dbisql -nogui -c "uid=dba;pwd=sql;eng=cons;dbf=rem%%i\rem%%i.db;autostop=no" read rem.sql %%i

@rem 
@rem Add the MobiLink Users to the consolidated database
@rem 
for /L %%i in (1,1,%num%) do mluser -c "dsn=MultiplePubsDelayHook" -u rem%%i -p sql

@rem 
@rem Start the MobiLink Server
@rem 
start mlsrv10 -v+ -ot mlsrv10.txt -c "dsn=MultiplePubsDelayHook"
pause

@rem 
@rem Start Synchronization for each remote database
@rem 
for /L %%i in (1,1,%num%) do start dbmlsync -c "eng=cons;dbn=rem%%i;uid=dba;pwd=sql" -mp sql -v+ -o rem%%i.txt -k -n p1 -n p2 -n p3
