parameters user_num;

set option public.Global_database_id = {user_num};
set option public.delete_old_logs = 'ON';

create table Admin1 (
  admin_id bigint default global autoincrement(1000000) primary key,
  data     varchar(30)
);

create table Admin2 (
  admin_id bigint default global autoincrement(1000000) primary key,
  data     varchar(30)
);

create table Admin3 (
  admin_id bigint default global autoincrement(1000000) primary key,
  data     varchar(30)
);

create procedure rep_data(in iter integer default 1,in do_commit integer default 0)
begin
  declare i integer;
  set i=0;
  while i < iter loop
    insert into admin1(data) values(cast(rand(*)*20+1 as char(10)));
    insert into admin2(data) values(cast(rand(*)*20+1 as char(10)));
    insert into admin3(data) values(cast(rand(*)*20+1 as char(10)));
    set i=i+1;
    if do_commit = 1 then
      commit;
    end if;
  end loop;
  commit;
end;

create publication p1 ( table Admin1 );
create publication p2 ( table Admin2 );
create publication p3 ( table Admin3 );
create synchronization user "rem{user_num}";
create synchronization subscription to p1 for "rem{user_num}" type 'tcpip' address 'host=localhost' option sv='v1',sch='every:00:00';
create synchronization subscription to p2 for "rem{user_num}" type 'tcpip' address 'host=localhost' option sv='v1',sch='every:00:00';
create synchronization subscription to p3 for "rem{user_num}" type 'tcpip' address 'host=localhost' option sv='v1',sch='every:00:00';

call rep_data( 2 );

-- The SynchSchedule table controls how often a publication synchronizes
-- with the value in the "interval" column, which is the number of 
-- seconds between synchronizations.  The max_delay 
-- If you set the "force_synch" column
-- to 1 at any time, it will force a synchronization for that 
-- publication on the next iteration of the 

create table SynchSchedule (
  pub_name      varchar(128) primary key,
  single_delay  integer not null default 5,
  max_delay     integer not null default 60,
  force_synch   integer not null default 0
);

insert into SynchSchedule values ( 'p1', 5,  15,  0 );
insert into SynchSchedule values ( 'p2', 10, 60,  0 );
insert into SynchSchedule values ( 'p3', 30, 120, 0 );

create procedure sp_hook_dbmlsync_delay ()
begin

    if exists ( select 1 
                  from SynchSchedule 
                 where pub_name in ( select value
                                       from #hook_dict
                                      where name like 'publication%' )
                   and force_synch = 1 ) then

        -- Force a synchronization to occur right now, and set
        -- the force_synch value back to zero
        
        update #hook_dict 
           set value = '0' 
         where name = 'delay duration';
        update SynchSchedule 
           set force_synch = 0 
         where pub_name in ( select value
                               from #hook_dict
                              where name like 'publication%' );
    else
    
        -- Find the minimum delay duration for all the publications
        -- being synchronized and set delay_duration value in the 
        -- #hook_dict table.  This defines the number of seconds until
        -- the hook is called again for these publications
        
        update #hook_dict 
           set value = ( select min(single_delay)
                           from SynchSchedule
                          where pub_name in ( select value
                                                from #hook_dict
                                               where name like 'publication%' ) )
         where name = 'delay duration';
    end if;
  
    -- Find the minimum max_delay value for all the publications
    -- being synchronized and set 'maximum accumulated delay' value in the 
    -- #hook_dict table.  If the total time that dbmlsync has waited between
    -- synchronizing these publications is ever greater than the 
    -- 'maximum accumulated delay' value in the #hook_dict table after the 
    -- call to sp_hook_dbmlsync_delay is complete, then a synchronization will
    -- occur
  
    update #hook_dict 
       set value = ( select min(max_delay)
                       from SynchSchedule
                      where pub_name in ( select value
                                            from #hook_dict
                                           where name like 'publication%' ) )
     WHERE name = 'maximum accumulated delay';
  
end;

